%ifndef SNEeSe_CPUmem_i
%define SNEeSe_CPUmem_i

%ifndef SNEeSe_memblank_asm

extern _memblank_text_start,_memblank_data_start,_memblank_bss_start
extern _LoROM_Blank,_HiROM_Blank
extern _Read_Bank8Mapping,_Write_Bank8Mapping
extern _Read_Bank8Offset,_Write_Bank8Offset
extern _Dummy
extern _RomReadAdjust,_RomReadAdjust2
extern _RomHiReadAdjust,_RomHiReadAdjust2
extern _HRomLinReadAdjust,_HRomHiLinReadAdjust
extern UNSUPPORTED_READ,_UNSUPPORTED_READ
extern UNSUPPORTED_WRITE,_UNSUPPORTED_WRITE
extern IGNORE_WRITE,_IGNORE_WRITE
extern _RAM_READ,_RAM_WRITE
extern _READ_00_3F_No_SRAM,_READ_80_BF_No_SRAM
extern _BlankL_00_3F,_BlankL_80_BF
extern _BlankH_00_3F_No_SRAM,_BlankH_80_BF_No_SRAM
extern _BlankL_40_6F,_BlankL_C0_FF
extern _BlankH_30,_BlankH_31,_BlankH_32,_BlankH_33
extern _BlankH_34,_BlankH_35,_BlankH_36,_BlankH_37
extern _BlankH_38,_BlankH_39,_BlankH_3A,_BlankH_3B
extern _BlankH_3C,_BlankH_3D,_BlankH_3E,_BlankH_3F
extern _BlankH_B0,_BlankH_B1,_BlankH_B2,_BlankH_B3
extern _BlankH_B4,_BlankH_B5,_BlankH_B6,_BlankH_B7
extern _BlankH_B8,_BlankH_B9,_BlankH_BA,_BlankH_BB
extern _BlankH_BC,_BlankH_BD,_BlankH_BE,_BlankH_BF
extern _BlankH_40_7D,_BlankH_C0_FF
extern _WRITE_00_3F,_WRITE_80_BF
extern _HWRITE_00_3F_No_SRAM,_HWRITE_80_BF_No_SRAM
extern _PPU_READ,_PPU_WRITE
%endif

%ifndef SNEeSe_memlo_asm
extern _memlo_text_start,_memlo_data_start,_memlo_bss_start
extern _LoROM_Write
extern _SRAM_READ,_SRAM_WRITE
extern _SRAM_WRITE_2k,_SRAM_WRITE_4k
extern _READ_00_3F_2,_READ_40_6F_2
extern _READ_80_BF_2,_READ_C0_FF_2
%endif

%ifndef SNEeSe_memhi_asm

extern _memhi_text_start,_memhi_data_start,_memhi_bss_start
extern _HiROM_Read,_HiROM_Write
extern _HiROM_Read_SRAM_ROM_30,_HiROM_Read_SRAM_ROM_B0
extern _HiROM_Read_SRAM_Blank_30,_HiROM_Read_SRAM_Blank_B0
extern _HiROM_Write_SRAM_30,_HiROM_Write_SRAM_B0
extern _HiROM_Read_No_SRAM_ROM_30,_HiROM_Read_No_SRAM_ROM_B0
extern _HiROM_Read_No_SRAM_Blank_30,_HiROM_Read_No_SRAM_Blank_B0
extern _HiROM_Write_No_SRAM_30,_HiROM_Write_No_SRAM_B0
extern _HREAD_30,_HREAD_31,_HREAD_32,_HREAD_33
extern _HREAD_34,_HREAD_35,_HREAD_36,_HREAD_37
extern _HREAD_38,_HREAD_39,_HREAD_3A,_HREAD_3B
extern _HREAD_3C,_HREAD_3D,_HREAD_3E,_HREAD_3F
extern _HREAD_B0,_HREAD_B1,_HREAD_B2,_HREAD_B3
extern _HREAD_B4,_HREAD_B5,_HREAD_B6,_HREAD_B7
extern _HREAD_B8,_HREAD_B9,_HREAD_BA,_HREAD_BB
extern _HREAD_BC,_HREAD_BD,_HREAD_BE,_HREAD_BF
extern _HREAD_40_7D,_HREAD_C0_FF
extern _HWRITE_3X_BX_2k,_HWRITE_3X_BX_4k
extern _HWRITE_30,_HWRITE_31,_HWRITE_32,_HWRITE_33
extern _HWRITE_34,_HWRITE_35,_HWRITE_36,_HWRITE_37
extern _HWRITE_38,_HWRITE_39,_HWRITE_3A,_HWRITE_3B
extern _HWRITE_3C,_HWRITE_3D,_HWRITE_3E,_HWRITE_3F
extern _HWRITE_B0,_HWRITE_B1,_HWRITE_B2,_HWRITE_B3
extern _HWRITE_B4,_HWRITE_B5,_HWRITE_B6,_HWRITE_B7
extern _HWRITE_B8,_HWRITE_B9,_HWRITE_BA,_HWRITE_BB
extern _HWRITE_BC,_HWRITE_BD,_HWRITE_BE,_HWRITE_BF
%endif

%if 0

Macro's included in this ASM header

All macros assume ebx contains 24-bit address, al or ax (depending on size)
the location to return data (for read) or accept data (for write) at.
edi is always corrupted.

GET_BYTE    Get byte from any bank
GET_WORD    Get word from any bank
SET_BYTE    Set byte in any bank
SET_WORD    Set word in any bank

GET_WORD may be passed an optional 'Reverse' parameter to skip the last
xchg. If this is done, the low byte will be returned in ah, high byte
in al.

SET_WORD may be passed an optional 'NoSave' parameter to prevent the
push/pop used to preserve the data word.

SET_WORD may be passed an optional 'Double' parameter to force it to
use al for both high and low bytes of write data. eax is not modified.

SET_WORD_HL is an alternate macros for when the address being passed in
is of the high byte, and the high byte will be written first. This
alternate macro does not support NoSave or Double.
%endif

%macro GET_BYTE 0
 mov edi,ebx
 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz %%read_direct
 mov edi,ebx
 shr edi,13
 call [_Read_Bank8Mapping+edi*4]
 jmp %%read_done
%%read_direct:
 mov al,[edi+ebx]
%%read_done:
%endmacro

;%1 = Reverse
%macro GET_WORD 0-1 0
 GET_BYTE
 mov ah,al
 inc ebx
 GET_BYTE
%ifnidni %1,Reverse
 xchg ah,al
%endif
%endmacro

%macro SET_BYTE 0
 mov edi,ebx
 shr edi,13
 mov edi,[_Write_Bank8Offset+edi*4]
 test edi,edi
 jnz %%write_direct
 mov edi,ebx
 shr edi,13
 call [_Write_Bank8Mapping+edi*4]
 jmp %%write_done
%%write_direct:
 mov [edi+ebx],al
%%write_done:
%endmacro

;%1 = NoSave/Double
%macro SET_WORD 0-1 0
 SET_BYTE
%ifnidni %1,Double
%ifnidni %1,NoSave
 push eax
%endif
 mov al,ah
%endif
 inc ebx
 SET_BYTE
%ifnidni %1,Double
%ifnidni %1,NoSave
 pop eax
%endif
%endif
%endmacro

%macro SET_WORD_HL 0
 push eax
 mov al,ah
 SET_BYTE
 pop eax
 dec ebx
 SET_BYTE
%endmacro

%endif ; !SNEeSe_CPUmem_i
